package org.spbu.bdd.core.impl;

import org.spbu.bdd.core.ITerminal;

public class TerminalImpl<E> extends NodeImpl implements ITerminal<E> {
	
	E value;
	
	public String toString() {
		return value.toString();
	}
		
	public TerminalImpl(E value) {
		super();
		this.value = value;		
	}

	public E getValue() {
		return value;
	}

	public boolean isTerm() {
		return true;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((value == null) ? 0 : value.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		TerminalImpl other = (TerminalImpl) obj;
		if (value == null) {
			if (other.value != null)
				return false;
		} else if (!value.equals(other.value))
			return false;
		return true;
	}
}
